/// <reference types="node" />
import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import * as beetSolana from '@metaplex-foundation/beet-solana';
export declare type ClaimCountArgs = {
    count: beet.bignum;
    claimant: web3.PublicKey;
};
export declare const claimCountDiscriminator: number[];
export declare class ClaimCount implements ClaimCountArgs {
    readonly count: beet.bignum;
    readonly claimant: web3.PublicKey;
    private constructor();
    static fromArgs(args: ClaimCountArgs): ClaimCount;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [ClaimCount, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<ClaimCount>;
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        count: any;
        claimant: any;
    }>;
    static deserialize(buf: Buffer, offset?: number): [ClaimCount, number];
    serialize(): [Buffer, number];
    static get byteSize(): number;
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    pretty(): {
        count: number | {
            toNumber: () => number;
        };
        claimant: string;
    };
}
export declare const claimCountBeet: beet.BeetStruct<ClaimCount, ClaimCountArgs & {
    accountDiscriminator: number[];
}>;
