"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.claimCountBeet = exports.ClaimCount = exports.claimCountDiscriminator = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
exports.claimCountDiscriminator = [78, 134, 220, 213, 34, 152, 102, 167];
class ClaimCount {
    constructor(count, claimant) {
        this.count = count;
        this.claimant = claimant;
    }
    static fromArgs(args) {
        return new ClaimCount(args.count, args.claimant);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return ClaimCount.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find ClaimCount account at ${address}`);
        }
        return ClaimCount.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.claimCountBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.claimCountBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.claimCountBeet.serialize({
            accountDiscriminator: exports.claimCountDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.claimCountBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(ClaimCount.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === ClaimCount.byteSize;
    }
    pretty() {
        return {
            count: (() => {
                const x = this.count;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            claimant: this.claimant.toBase58(),
        };
    }
}
exports.ClaimCount = ClaimCount;
exports.claimCountBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['count', beet.u64],
    ['claimant', beetSolana.publicKey],
], ClaimCount.fromArgs, 'ClaimCount');
//# sourceMappingURL=ClaimCount.js.map