/// <reference types="node" />
import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
import * as beetSolana from '@metaplex-foundation/beet-solana';
export declare type ClaimProofArgs = {
    amount: beet.bignum;
    count: beet.bignum;
    claimant: web3.PublicKey;
    resource: web3.PublicKey;
    resourceNonce: Uint8Array;
};
export declare const claimProofDiscriminator: number[];
export declare class ClaimProof implements ClaimProofArgs {
    readonly amount: beet.bignum;
    readonly count: beet.bignum;
    readonly claimant: web3.PublicKey;
    readonly resource: web3.PublicKey;
    readonly resourceNonce: Uint8Array;
    private constructor();
    static fromArgs(args: ClaimProofArgs): ClaimProof;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [ClaimProof, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<ClaimProof>;
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        count: any;
        claimant: any;
        amount: any;
        resource: any;
        resourceNonce: any;
    }>;
    static deserialize(buf: Buffer, offset?: number): [ClaimProof, number];
    serialize(): [Buffer, number];
    static byteSize(args: ClaimProofArgs): number;
    static getMinimumBalanceForRentExemption(args: ClaimProofArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    pretty(): {
        amount: number | {
            toNumber: () => number;
        };
        count: number | {
            toNumber: () => number;
        };
        claimant: string;
        resource: string;
        resourceNonce: Uint8Array;
    };
}
export declare const claimProofBeet: beet.FixableBeetStruct<ClaimProof, ClaimProofArgs & {
    accountDiscriminator: number[];
}>;
