"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.claimProofBeet = exports.ClaimProof = exports.claimProofDiscriminator = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
exports.claimProofDiscriminator = [48, 173, 176, 137, 53, 116, 40, 112];
class ClaimProof {
    constructor(amount, count, claimant, resource, resourceNonce) {
        this.amount = amount;
        this.count = count;
        this.claimant = claimant;
        this.resource = resource;
        this.resourceNonce = resourceNonce;
    }
    static fromArgs(args) {
        return new ClaimProof(args.amount, args.count, args.claimant, args.resource, args.resourceNonce);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return ClaimProof.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find ClaimProof account at ${address}`);
        }
        return ClaimProof.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.claimProofBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.claimProofBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.claimProofBeet.serialize({
            accountDiscriminator: exports.claimProofDiscriminator,
            ...this,
        });
    }
    static byteSize(args) {
        const instance = ClaimProof.fromArgs(args);
        return exports.claimProofBeet.toFixedFromValue({
            accountDiscriminator: exports.claimProofDiscriminator,
            ...instance,
        }).byteSize;
    }
    static async getMinimumBalanceForRentExemption(args, connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(ClaimProof.byteSize(args), commitment);
    }
    pretty() {
        return {
            amount: (() => {
                const x = this.amount;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            count: (() => {
                const x = this.count;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            claimant: this.claimant.toBase58(),
            resource: this.resource.toBase58(),
            resourceNonce: this.resourceNonce,
        };
    }
}
exports.ClaimProof = ClaimProof;
exports.claimProofBeet = new beet.FixableBeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['amount', beet.u64],
    ['count', beet.u64],
    ['claimant', beetSolana.publicKey],
    ['resource', beetSolana.publicKey],
    ['resourceNonce', beet.bytes],
], ClaimProof.fromArgs, 'ClaimProof');
//# sourceMappingURL=ClaimProof.js.map