/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';
export declare type ClaimStatusArgs = {
    isClaimed: boolean;
    claimant: web3.PublicKey;
    claimedAt: beet.bignum;
    amount: beet.bignum;
};
export declare const claimStatusDiscriminator: number[];
export declare class ClaimStatus implements ClaimStatusArgs {
    readonly isClaimed: boolean;
    readonly claimant: web3.PublicKey;
    readonly claimedAt: beet.bignum;
    readonly amount: beet.bignum;
    private constructor();
    static fromArgs(args: ClaimStatusArgs): ClaimStatus;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [ClaimStatus, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<ClaimStatus>;
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        accountDiscriminator: any;
        claimant: any;
        amount: any;
        isClaimed: any;
        claimedAt: any;
    }>;
    static deserialize(buf: Buffer, offset?: number): [ClaimStatus, number];
    serialize(): [Buffer, number];
    static get byteSize(): number;
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    pretty(): {
        isClaimed: boolean;
        claimant: string;
        claimedAt: number | {
            toNumber: () => number;
        };
        amount: number | {
            toNumber: () => number;
        };
    };
}
export declare const claimStatusBeet: beet.BeetStruct<ClaimStatus, ClaimStatusArgs & {
    accountDiscriminator: number[];
}>;
