"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.claimStatusBeet = exports.ClaimStatus = exports.claimStatusDiscriminator = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
exports.claimStatusDiscriminator = [22, 183, 249, 157, 247, 95, 150, 96];
class ClaimStatus {
    constructor(isClaimed, claimant, claimedAt, amount) {
        this.isClaimed = isClaimed;
        this.claimant = claimant;
        this.claimedAt = claimedAt;
        this.amount = amount;
    }
    static fromArgs(args) {
        return new ClaimStatus(args.isClaimed, args.claimant, args.claimedAt, args.amount);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return ClaimStatus.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find ClaimStatus account at ${address}`);
        }
        return ClaimStatus.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.claimStatusBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.claimStatusBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.claimStatusBeet.serialize({
            accountDiscriminator: exports.claimStatusDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.claimStatusBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(ClaimStatus.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === ClaimStatus.byteSize;
    }
    pretty() {
        return {
            isClaimed: this.isClaimed,
            claimant: this.claimant.toBase58(),
            claimedAt: (() => {
                const x = this.claimedAt;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
            amount: (() => {
                const x = this.amount;
                if (typeof x.toNumber === 'function') {
                    try {
                        return x.toNumber();
                    }
                    catch (_) {
                        return x;
                    }
                }
                return x;
            })(),
        };
    }
}
exports.ClaimStatus = ClaimStatus;
exports.claimStatusBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['isClaimed', beet.bool],
    ['claimant', beetSolana.publicKey],
    ['claimedAt', beet.i64],
    ['amount', beet.u64],
], ClaimStatus.fromArgs, 'ClaimStatus');
//# sourceMappingURL=ClaimStatus.js.map