/// <reference types="node" />
import * as web3 from '@solana/web3.js';
import * as beetSolana from '@metaplex-foundation/beet-solana';
import * as beet from '@metaplex-foundation/beet';
import { ConfigData } from '../types/ConfigData';
export declare type ConfigArgs = {
    authority: web3.PublicKey;
    data: ConfigData;
};
export declare const configDiscriminator: number[];
export declare class Config implements ConfigArgs {
    readonly authority: web3.PublicKey;
    readonly data: ConfigData;
    private constructor();
    static fromArgs(args: ConfigArgs): Config;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [Config, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey): Promise<Config>;
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        authority: any;
        data: any;
        accountDiscriminator: any;
    }>;
    static deserialize(buf: Buffer, offset?: number): [Config, number];
    serialize(): [Buffer, number];
    static byteSize(args: ConfigArgs): number;
    static getMinimumBalanceForRentExemption(args: ConfigArgs, connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    pretty(): {
        authority: string;
        data: ConfigData;
    };
}
export declare const configBeet: beet.FixableBeetStruct<Config, ConfigArgs & {
    accountDiscriminator: number[];
}>;
