"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.configBeet = exports.Config = exports.configDiscriminator = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const ConfigData_1 = require("../types/ConfigData");
exports.configDiscriminator = [155, 12, 170, 224, 30, 250, 204, 130];
class Config {
    constructor(authority, data) {
        this.authority = authority;
        this.data = data;
    }
    static fromArgs(args) {
        return new Config(args.authority, args.data);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return Config.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find Config account at ${address}`);
        }
        return Config.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.configBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.configBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.configBeet.serialize({
            accountDiscriminator: exports.configDiscriminator,
            ...this,
        });
    }
    static byteSize(args) {
        const instance = Config.fromArgs(args);
        return exports.configBeet.toFixedFromValue({
            accountDiscriminator: exports.configDiscriminator,
            ...instance,
        }).byteSize;
    }
    static async getMinimumBalanceForRentExemption(args, connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(Config.byteSize(args), commitment);
    }
    pretty() {
        return {
            authority: this.authority.toBase58(),
            data: this.data,
        };
    }
}
exports.Config = Config;
exports.configBeet = new beet.FixableBeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['authority', beetSolana.publicKey],
    ['data', ConfigData_1.configDataBeet],
], Config.fromArgs, 'Config');
//# sourceMappingURL=Config.js.map