"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.merkleDistributorBeet = exports.MerkleDistributor = exports.merkleDistributorDiscriminator = void 0;
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
const beet = __importStar(require("@metaplex-foundation/beet"));
exports.merkleDistributorDiscriminator = [77, 119, 139, 70, 84, 247, 12, 26];
class MerkleDistributor {
    constructor(base, bump, root, temporal) {
        this.base = base;
        this.bump = bump;
        this.root = root;
        this.temporal = temporal;
    }
    static fromArgs(args) {
        return new MerkleDistributor(args.base, args.bump, args.root, args.temporal);
    }
    static fromAccountInfo(accountInfo, offset = 0) {
        return MerkleDistributor.deserialize(accountInfo.data, offset);
    }
    static async fromAccountAddress(connection, address) {
        const accountInfo = await connection.getAccountInfo(address);
        if (accountInfo == null) {
            throw new Error(`Unable to find MerkleDistributor account at ${address}`);
        }
        return MerkleDistributor.fromAccountInfo(accountInfo, 0)[0];
    }
    static gpaBuilder(programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
        return beetSolana.GpaBuilder.fromStruct(programId, exports.merkleDistributorBeet);
    }
    static deserialize(buf, offset = 0) {
        return exports.merkleDistributorBeet.deserialize(buf, offset);
    }
    serialize() {
        return exports.merkleDistributorBeet.serialize({
            accountDiscriminator: exports.merkleDistributorDiscriminator,
            ...this,
        });
    }
    static get byteSize() {
        return exports.merkleDistributorBeet.byteSize;
    }
    static async getMinimumBalanceForRentExemption(connection, commitment) {
        return connection.getMinimumBalanceForRentExemption(MerkleDistributor.byteSize, commitment);
    }
    static hasCorrectByteSize(buf, offset = 0) {
        return buf.byteLength - offset === MerkleDistributor.byteSize;
    }
    pretty() {
        return {
            base: this.base.toBase58(),
            bump: this.bump,
            root: this.root,
            temporal: this.temporal.toBase58(),
        };
    }
}
exports.MerkleDistributor = MerkleDistributor;
exports.merkleDistributorBeet = new beet.BeetStruct([
    ['accountDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['base', beetSolana.publicKey],
    ['bump', beet.u8],
    ['root', beet.uniformFixedSizeArray(beet.u8, 32)],
    ['temporal', beetSolana.publicKey],
], MerkleDistributor.fromArgs, 'MerkleDistributor');
//# sourceMappingURL=MerkleDistributor.js.map