declare type ErrorWithCode = Error & {
    code: number;
};
declare type MaybeErrorWithCode = ErrorWithCode | null | undefined;
export declare class InvalidProofError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class DropAlreadyClaimedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class UnauthorizedError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class OwnerMismatchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class TemporalMismatchError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class NumericalOverflowError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class InvalidClaimBumpError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class MustUseOfficialCandyMachineError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare class BumpSeedNotInHashMapError extends Error {
    readonly code: number;
    readonly name: string;
    constructor();
}
export declare function errorFromCode(code: number): MaybeErrorWithCode;
export declare function errorFromName(name: string): MaybeErrorWithCode;
export {};
