import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type ClaimInstructionArgs = {
    claimBump: number;
    index: beet.bignum;
    amount: beet.bignum;
    claimantSecret: web3.PublicKey;
    proof: number[][];
};
export declare const claimStruct: beet.FixableBeetArgsStruct<ClaimInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type ClaimInstructionAccounts = {
    distributor: web3.PublicKey;
    claimStatus: web3.PublicKey;
    from: web3.PublicKey;
    to: web3.PublicKey;
    temporal: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
};
export declare const claimInstructionDiscriminator: number[];
export declare function createClaimInstruction(accounts: ClaimInstructionAccounts, args: ClaimInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
