import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type ClaimCandyInstructionArgs = {
    walletBump: number;
    claimBump: number;
    index: beet.bignum;
    amount: beet.bignum;
    claimantSecret: web3.PublicKey;
    proof: number[][];
};
export declare const claimCandyStruct: beet.FixableBeetArgsStruct<ClaimCandyInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type ClaimCandyInstructionAccounts = {
    distributor: web3.PublicKey;
    distributorWallet: web3.PublicKey;
    claimCount: web3.PublicKey;
    temporal: web3.PublicKey;
    payer: web3.PublicKey;
    candyMachineConfig: web3.PublicKey;
    candyMachine: web3.PublicKey;
    candyMachineWallet: web3.PublicKey;
    candyMachineMint: web3.PublicKey;
    candyMachineMetadata: web3.PublicKey;
    candyMachineMasterEdition: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
    tokenMetadataProgram: web3.PublicKey;
    candyMachineProgram: web3.PublicKey;
    rent?: web3.PublicKey;
    clock: web3.PublicKey;
};
export declare const claimCandyInstructionDiscriminator: number[];
export declare function createClaimCandyInstruction(accounts: ClaimCandyInstructionAccounts, args: ClaimCandyInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
