import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type ClaimCandyProvenInstructionArgs = {
    walletBump: number;
    claimBump: number;
    index: beet.bignum;
};
export declare const claimCandyProvenStruct: beet.BeetArgsStruct<ClaimCandyProvenInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type ClaimCandyProvenInstructionAccounts = {
    distributor: web3.PublicKey;
    distributorWallet: web3.PublicKey;
    claimProof: web3.PublicKey;
    payer: web3.PublicKey;
    candyMachineConfig: web3.PublicKey;
    candyMachine: web3.PublicKey;
    candyMachineWallet: web3.PublicKey;
    candyMachineMint: web3.PublicKey;
    candyMachineMetadata: web3.PublicKey;
    candyMachineMasterEdition: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
    tokenMetadataProgram: web3.PublicKey;
    candyMachineProgram: web3.PublicKey;
    rent?: web3.PublicKey;
    clock: web3.PublicKey;
};
export declare const claimCandyProvenInstructionDiscriminator: number[];
export declare function createClaimCandyProvenInstruction(accounts: ClaimCandyProvenInstructionAccounts, args: ClaimCandyProvenInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
