import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type ClaimEditionInstructionArgs = {
    claimBump: number;
    index: beet.bignum;
    amount: beet.bignum;
    edition: beet.bignum;
    claimantSecret: web3.PublicKey;
    proof: number[][];
};
export declare const claimEditionStruct: beet.FixableBeetArgsStruct<ClaimEditionInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type ClaimEditionInstructionAccounts = {
    distributor: web3.PublicKey;
    claimCount: web3.PublicKey;
    temporal: web3.PublicKey;
    payer: web3.PublicKey;
    metadataNewMetadata: web3.PublicKey;
    metadataNewEdition: web3.PublicKey;
    metadataMasterEdition: web3.PublicKey;
    metadataNewMint: web3.PublicKey;
    metadataEditionMarkPda: web3.PublicKey;
    metadataNewMintAuthority: web3.PublicKey;
    metadataMasterTokenAccount: web3.PublicKey;
    metadataNewUpdateAuthority: web3.PublicKey;
    metadataMasterMetadata: web3.PublicKey;
    metadataMasterMint: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
    tokenMetadataProgram: web3.PublicKey;
    rent?: web3.PublicKey;
};
export declare const claimEditionInstructionDiscriminator: number[];
export declare function createClaimEditionInstruction(accounts: ClaimEditionInstructionAccounts, args: ClaimEditionInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
