"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClaimEditionInstruction = exports.claimEditionInstructionDiscriminator = exports.claimEditionStruct = void 0;
const splToken = __importStar(require("@solana/spl-token"));
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
exports.claimEditionStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['claimBump', beet.u8],
    ['index', beet.u64],
    ['amount', beet.u64],
    ['edition', beet.u64],
    ['claimantSecret', beetSolana.publicKey],
    ['proof', beet.array(beet.uniformFixedSizeArray(beet.u8, 32))],
], 'ClaimEditionInstructionArgs');
exports.claimEditionInstructionDiscriminator = [150, 83, 124, 180, 53, 35, 144, 248];
function createClaimEditionInstruction(accounts, args, programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
    var _a, _b, _c;
    const [data] = exports.claimEditionStruct.serialize({
        instructionDiscriminator: exports.claimEditionInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: accounts.distributor,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.claimCount,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.temporal,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: accounts.payer,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: accounts.metadataNewMetadata,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataNewEdition,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataMasterEdition,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataNewMint,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataEditionMarkPda,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataNewMintAuthority,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: accounts.metadataMasterTokenAccount,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataNewUpdateAuthority,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataMasterMetadata,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: accounts.metadataMasterMint,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: (_a = accounts.systemProgram) !== null && _a !== void 0 ? _a : web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: (_b = accounts.tokenProgram) !== null && _b !== void 0 ? _b : splToken.TOKEN_PROGRAM_ID,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: accounts.tokenMetadataProgram,
            isWritable: false,
            isSigner: false,
        },
        {
            pubkey: (_c = accounts.rent) !== null && _c !== void 0 ? _c : web3.SYSVAR_RENT_PUBKEY,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId,
        keys,
        data,
    });
    return ix;
}
exports.createClaimEditionInstruction = createClaimEditionInstruction;
//# sourceMappingURL=claimEdition.js.map