import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type CloseDistributorInstructionArgs = {
    bump: number;
    walletBump: number;
};
export declare const closeDistributorStruct: beet.BeetArgsStruct<CloseDistributorInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type CloseDistributorInstructionAccounts = {
    base: web3.PublicKey;
    distributor: web3.PublicKey;
    distributorWallet: web3.PublicKey;
    receiver: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
};
export declare const closeDistributorInstructionDiscriminator: number[];
export declare function createCloseDistributorInstruction(accounts: CloseDistributorInstructionAccounts, args: CloseDistributorInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
