import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
export declare type NewDistributorInstructionArgs = {
    bump: number;
    root: number[];
    temporal: web3.PublicKey;
};
export declare const newDistributorStruct: beet.BeetArgsStruct<NewDistributorInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type NewDistributorInstructionAccounts = {
    base: web3.PublicKey;
    distributor: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
};
export declare const newDistributorInstructionDiscriminator: number[];
export declare function createNewDistributorInstruction(accounts: NewDistributorInstructionAccounts, args: NewDistributorInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
