import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type ProveClaimInstructionArgs = {
    claimPrefix: Uint8Array;
    claimBump: number;
    index: beet.bignum;
    amount: beet.bignum;
    claimantSecret: web3.PublicKey;
    resource: web3.PublicKey;
    resourceNonce: Uint8Array;
    proof: number[][];
};
export declare const proveClaimStruct: beet.FixableBeetArgsStruct<ProveClaimInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type ProveClaimInstructionAccounts = {
    distributor: web3.PublicKey;
    claimProof: web3.PublicKey;
    temporal: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
};
export declare const proveClaimInstructionDiscriminator: number[];
export declare function createProveClaimInstruction(accounts: ProveClaimInstructionAccounts, args: ProveClaimInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
