"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProveClaimInstruction = exports.proveClaimInstructionDiscriminator = exports.proveClaimStruct = void 0;
const beet = __importStar(require("@metaplex-foundation/beet"));
const web3 = __importStar(require("@solana/web3.js"));
const beetSolana = __importStar(require("@metaplex-foundation/beet-solana"));
exports.proveClaimStruct = new beet.FixableBeetArgsStruct([
    ['instructionDiscriminator', beet.uniformFixedSizeArray(beet.u8, 8)],
    ['claimPrefix', beet.bytes],
    ['claimBump', beet.u8],
    ['index', beet.u64],
    ['amount', beet.u64],
    ['claimantSecret', beetSolana.publicKey],
    ['resource', beetSolana.publicKey],
    ['resourceNonce', beet.bytes],
    ['proof', beet.array(beet.uniformFixedSizeArray(beet.u8, 32))],
], 'ProveClaimInstructionArgs');
exports.proveClaimInstructionDiscriminator = [52, 82, 123, 224, 40, 139, 230, 184];
function createProveClaimInstruction(accounts, args, programId = new web3.PublicKey('gdrpGjVffourzkdDRrQmySw4aTHr8a3xmQzzxSwFD1a')) {
    var _a;
    const [data] = exports.proveClaimStruct.serialize({
        instructionDiscriminator: exports.proveClaimInstructionDiscriminator,
        ...args,
    });
    const keys = [
        {
            pubkey: accounts.distributor,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.claimProof,
            isWritable: true,
            isSigner: false,
        },
        {
            pubkey: accounts.temporal,
            isWritable: false,
            isSigner: true,
        },
        {
            pubkey: accounts.payer,
            isWritable: true,
            isSigner: true,
        },
        {
            pubkey: (_a = accounts.systemProgram) !== null && _a !== void 0 ? _a : web3.SystemProgram.programId,
            isWritable: false,
            isSigner: false,
        },
    ];
    const ix = new web3.TransactionInstruction({
        programId,
        keys,
        data,
    });
    return ix;
}
exports.createProveClaimInstruction = createProveClaimInstruction;
//# sourceMappingURL=proveClaim.js.map