import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';
export declare type RecoverUpdateAuthorityInstructionArgs = {
    bump: number;
    walletBump: number;
};
export declare const recoverUpdateAuthorityStruct: beet.BeetArgsStruct<RecoverUpdateAuthorityInstructionArgs & {
    instructionDiscriminator: number[];
}>;
export declare type RecoverUpdateAuthorityInstructionAccounts = {
    base: web3.PublicKey;
    distributor: web3.PublicKey;
    distributorWallet: web3.PublicKey;
    newUpdateAuthority: web3.PublicKey;
    metadata: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    tokenMetadataProgram: web3.PublicKey;
};
export declare const recoverUpdateAuthorityInstructionDiscriminator: number[];
export declare function createRecoverUpdateAuthorityInstruction(accounts: RecoverUpdateAuthorityInstructionAccounts, args: RecoverUpdateAuthorityInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
